﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Net.Http;
using System.Web.Hosting;
using System.Web;
using System.Web.Http;
using System.Web.UI.WebControls;
using Keyoti.RapidSpell.WCF;
using ParameterCollection = Keyoti.RapidSpell.WCF.ParameterCollection;

namespace WebApplication1
{
    //[Route("[controller]")]
    [AllowAnonymous]
    public class RapidSpellAPIController : ApiController
    {
        //private readonly IHostingEnvironment _hostingEnvironment;
        //IObjectProvider objectProvider;
        //Microsoft.Extensions.Configuration.IConfiguration configuration;

        //public RapidSpellAPIController(IHostingEnvironment hostingEnvironment, IObjectProvider objectProvider = null, Microsoft.Extensions.Configuration.IConfiguration configuration = null)
        //{
        //    _hostingEnvironment = hostingEnvironment;
        //    this.objectProvider = objectProvider;
        //    this.configuration = configuration;
        //}

        //public RapidSpellAPIController(IHttpCon)

        //[HttpPost()]
        //public CheckResponseWrapper Check([FromBody] string s)
        //{
        //    return null;
        //}

        [HttpPost()]
        [Route("api/RapidSpellAPI/Check")]
        public CheckResponseWrapper Check([FromBody] object s)
        {/*
            IObjectProvider objectProvider = null;

            var objectProviderType = Type.GetType("RapidSpellExtension.ObjectProvider", false, true);
            if (objectProviderType != null)
            {
                objectProvider = Activator.CreateInstance(objectProviderType) as IObjectProvider;
            }

            */

            Dictionary<string, object> data = (Dictionary<string, object>)Keyoti.RapidSpell.fastJSON.JSON.Parse(s.ToString());
            ParameterCollection spellParameters = new Keyoti.RapidSpell.WCF.ParameterCollection(50);
            string textToCheck = data["textToCheck"].ToString();
            List<object> parameterList = ((List<object>)data["parameters"]);
            BuildParameters(parameterList, spellParameters);
            InlineService service = new InlineService();


            return service.Check(textToCheck, spellParameters, Request.Headers.Host, GetCookies(), null, null/*, objectProvider, configuration*/);

        }

        private string MapPath(string url)
        {
            //if (url.StartsWith("~/"))
            //{
            //    url = url.Replace("~/", "");
            //    if (string.IsNullOrEmpty(_hostingEnvironment.WebRootPath))
            //    {
            //        _hostingEnvironment.WebRootPath = System.IO.Directory.GetCurrentDirectory();
            //    }
            //    return System.IO.Path.Combine(_hostingEnvironment.WebRootPath, url);

            //}
            //else return url;
            if(String.IsNullOrEmpty (url))
            {
                url = "/";
            }

            return System.Web.Hosting.HostingEnvironment.MapPath(url);
        }

        private Dictionary<string, string> GetCookies()
        {
            Dictionary<string, string> cookies = new Dictionary<string, string>();
            foreach (var cookie in Request.Headers.GetCookies())
            {
                cookies[cookie.Cookies.FirstOrDefault().Name] = cookie.Cookies.FirstOrDefault().Value;//TODO Is this correct?
            }

            return cookies;
        }

        public class AddParameters
        {
            public string Word { get; set; }
            public string GuiLanguage { get; set; }
            public string UserDictionaryFile { get; set; }
        }

        [HttpPost()]
        [Route("api/RapidSpellAPI/AddWord")]
        public bool AddWord([FromBody] AddParameters p)// object s)
        {
            p.Word = WebUtility.HtmlDecode(p.Word);
            InlineService service = new InlineService();
            p.UserDictionaryFile = MapPath(p.UserDictionaryFile);
            //if (objectProvider != null)
            //{
            //    var ud = objectProvider.GetUserDictionary(p.UserDictionaryFile);
            //    if (ud != null)
            //        return service.AddWord(p.Word, p.GuiLanguage, p.UserDictionaryFile, ud);
            //}
            return service.AddWord(p.Word, p.GuiLanguage, p.UserDictionaryFile);
        }



        [HttpPost()]
        [Route("api/RapidSpellAPI/CheckMulti")]
        public CheckMultiResponseWrapper CheckMulti([FromBody] object parametersArray_obj)
        {
            Dictionary<string, object> data = (Dictionary<string, object>)Keyoti.RapidSpell.fastJSON.JSON.Parse(parametersArray_obj.ToString());
            List<object> dataList = ((List<object>)data["parametersArray"]);
            ParameterCollection[] parametersArray = new ParameterCollection[dataList.Count];
            int i = 0;
            foreach (List<object> paramseterSet in dataList)
            {
                ParameterCollection spellParameters = new ParameterCollection(40);
                BuildParameters(paramseterSet, spellParameters);

                parametersArray[i++] = spellParameters;
            }

            InlineService service = new InlineService();
            return service.CheckMulti(parametersArray, HttpContext.Current.Request.Url.Host, GetCookies(), null, null/*,objectProvider, configuration*/);
        }

        private void BuildParameters(List<object> paramseterSet, ParameterCollection spellParameters)
        {
            foreach (Dictionary<string, object> parameterListItemC in paramseterSet)
            {
                if (parameterListItemC["ParameterName"].ToString() == "UserDictionaryFile")
                {
                    parameterListItemC["ParameterValue"] = MapPath(parameterListItemC["ParameterValue"].ToString());
                }
                if (parameterListItemC["ParameterName"].ToString() == "DictFile")
                {
                    parameterListItemC["ParameterValue"] = MapPath(parameterListItemC["ParameterValue"].ToString());
                }
                spellParameters.Add(new SpellParameter() { ParameterName = parameterListItemC["ParameterName"].ToString(), ParameterValue = parameterListItemC["ParameterValue"].ToString() });

            }
        }
    }

    //public class ParameterCollection : List<SpellParameter>
    //{//DO NOT MAKE COLLECTIONS LIKE THIS [Serializable()] as this causes SOAP to serialize differently (=> _items collection)
    //    /// <summary>
    //    /// Gets a result.
    //    /// </summary>
    //    /// <param name="index">The result number, 0 based.</param>
    //    public new SpellParameter this[int index]
    //    {
    //        get { return base[index] as SpellParameter; }
    //        set { base[index] = value; }
    //    }

    //    ParameterCollection()
    //        : base()
    //    {

    //    }

    //    /// <summary>
    //    /// New
    //    /// </summary>
    //    /// <param name="capacity"></param>
    //    public ParameterCollection(int capacity)
    //        : base(capacity)
    //    {

    //    }



    //}



    ///// <summary>
    ///// Helper
    ///// </summary>
    //[System.Runtime.Serialization.DataContract]
    //public class SpellParameter
    //{// {'ParameterName': 'IgnoreXML', 'ParameterValue': 'true'}
    //    /// <summary>
    //    /// New (this is to support serialization).
    //    /// </summary>
    //    //internal SpellParameter()
    //    public SpellParameter()//i made this public to support WEB API controllers, hopefully it wont break something else?
    //    {
    //    }


    //    string name;
    //    /// <summary>
    //    /// The param name.
    //    /// </summary>
    //    [System.Runtime.Serialization.DataMemberAttribute]
    //    public string ParameterName
    //    {
    //        get { return name; }
    //        set { name = value; }
    //    }

    //    string pvalue;
    //    /// <summary>
    //    /// The param value.
    //    /// </summary>
    //    [System.Runtime.Serialization.DataMemberAttribute]
    //    public string ParameterValue
    //    {
    //        get { return pvalue; }
    //        set { pvalue = value; }
    //    }

    //}



    ///// <summary>
    ///// Helper
    ///// </summary>
    //[System.Runtime.Serialization.DataContract()]
    //public class CheckResponseWrapper
    //{

    //    string _Value;
    //    /// <summary>
    //    /// Helper
    //    /// </summary>
    //    [System.Runtime.Serialization.DataMemberAttribute()]
    //    public string value { get { return _Value; } set { _Value = value; } }

    //    String _Exception;
    //    /// <summary>
    //    /// Helper
    //    /// </summary>
    //    [System.Runtime.Serialization.DataMemberAttribute()]
    //    public String Exception { get { return _Exception; } set { _Exception = value; } }
    //}

    ///// <summary>
    ///// Helper
    ///// </summary>
    //[System.Runtime.Serialization.DataContract()]
    //public class CheckMultiResponseWrapper
    //{
    //    BadWordWrapper[][] _Value;
    //    /// <summary>
    //    /// Helper
    //    /// </summary>
    //    [System.Runtime.Serialization.DataMemberAttribute()]
    //    public BadWordWrapper[][] value { get { return _Value; } set { _Value = value; } }

    //    String _Exception;
    //    /// <summary>
    //    /// Helper
    //    /// </summary>
    //    [System.Runtime.Serialization.DataMemberAttribute()]
    //    public String exception { get { return _Exception; } set { _Exception = value; } }
    //}

    /// <summary>
    /// Helper
    /// </summary>
    [System.Runtime.Serialization.DataContract()]
    public class BadWordWrapper
    {
        /*
         * output.Write("    badWords = [");

				BadWord bw;
				ArrayList suggs;
                string spellText = text;

                int ptr = -1, eptr=0;
                string spaces;
                while (eptr!=-1 && (ptr = text.IndexOf("<!--rs_ignore-", eptr)) > -1)
                {
                    spaces = "";
                    eptr = text.IndexOf("<!--rs_ignore_end-->", ptr) + "<!--rs_ignore_end-->".Length;
                    for(int i=0; i<eptr-ptr; i++)
                        spaces += " ";
                    spellText = spellText.Substring(0, ptr) + spaces + text.Substring(eptr);
                }
                    
				CheckerEngine.Check(spellText, true);
				int c=0;
				try
				{
					while ( (bw = CheckerEngine.NextBadWord()) != null) 
					{
						if (c > 0)
							output.Write(",");
						c++;
						output.Write("{text:\""+bw.GetWord().Replace("\\", "\\\\").Replace("\"", "\\\"")+"\",e:\""+Page.Server.UrlEncode(bw.GetWord())+"\",start:" + bw.GetStartPosition() + ",end:" + bw.GetEndPosition() +
							",suggestions:[");
         */



        string _Text;
        /// <summary>
        /// Helper
        /// </summary>
        [System.Runtime.Serialization.DataMemberAttribute()]
        public string text { get { return _Text; } set { _Text = value; } }
        /*
        string _E;
        [System.Runtime.Serialization.DataMemberAttribute()]
        public string E { get { return _E; } set { _E = value; } }
        */
        int _start;
        /// <summary>
        /// Helper
        /// </summary>
        [System.Runtime.Serialization.DataMemberAttribute()]
        public int start { get { return _start; } set { _start = value; } }

        int _end;
        /// <summary>
        /// Helper
        /// </summary>
        [System.Runtime.Serialization.DataMemberAttribute()]
        public int end { get { return _end; } set { _end = value; } }

        string[] _suggestions;
        /// <summary>
        /// Helper
        /// </summary>
        [System.Runtime.Serialization.DataMemberAttribute()]
        public string[] suggestions { get { return _suggestions; } set { _suggestions = value; } }

        String _Exception;
        /// <summary>
        /// Helper
        /// </summary>
        [System.Runtime.Serialization.DataMemberAttribute()]
        public String Exception { get { return _Exception; } set { _Exception = value; } }
    }
}
